Name: remctl
Version: 3.3
Release: 1%{?dist}
Summary: Client/server for Kerberos-authenticated command execution

Group: Applications/Internet
License: MIT
URL: http://www.eyrie.org/~eagle/software/remctl
Source0: http://archives.eyrie.org/software/kerberos/remctl-%{version}.tar.gz
Source1: remctl.ini
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

BuildRequires: krb5-devel
BuildRequires: perl(ExtUtils::MakeMaker)
BuildRequires: php-devel
BuildRequires: python2-devel
%if 0%{?rhel} && 0%{?rhel} <= 6
BuildRequires: ruby
BuildRequires: ruby(abi) = 1.8
%endif
BuildRequires: ruby-devel

# RHEL 5/6 compatibility for PHP
%if 0%{?el5}
%global php_apiver  %((echo 0; php -i 2>/dev/null | sed -n 's/^PHP API => //p') | tail -1)
%{!?php_extdir: %{expand: %%global php_extdir %(php-config --extension-dir)}}
%endif
%if 0%{?el5} || 0%{?el6}
%{!?php_inidir:	%{expand: %%global php_inidir %{_sysconfdir}/php.d }}
%endif

# RHEL 5 compatibility for Python
%if 0%{?el5}
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

# RHEL 5/6 compatibility for Ruby
%if 0%{?el5}
%{!?ruby_vendorarchdir: %global ruby_vendorarchdir %(ruby -rrbconfig -e 'puts Config::CONFIG["sitearchdir"] ')}
%endif
%if 0%{?el6}
%{!?ruby_vendorarchdir: %global ruby_vendorarchdir %(ruby -rrbconfig -e 'puts Config::CONFIG["vendorarchdir"] ')}
%endif


%description

remctl (the client) and remctld (the server) implement a client/server
protocol for running single commands on a remote host using Kerberos
v5 authentication and returning the output. They use a very simple
GSS-API-authenticated network protocol, combined with server-side ACL
support and a server configuration file that maps remctl commands to
programs that should be run when that command is called by an
authorised user.

%package devel
Summary: Development files needed to compile C programs against remctl
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel

remctl implements a client/server protocol for running single commands
on a remote host using Kerberos v5 authentication. If you want to develop
programs which use remctl's libraries, you need to install this package.

%package perl
Summary: Perl interface to remctl
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%description perl
remctl implements a client/server protocol for running single commands 
on a remote host using Kerberos v5 authentication. If you want to use
remctl's Perl bindings, you need to install this package.

%package php
Summary: PHP interface to remctl
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
%if 0%{?el5}
Requires:     php-api = %{php_apiver}
%else
Requires:     php(zend-abi) = %{php_zend_api}
Requires:     php(api) = %{php_core_api}
%endif

%description php
remctl implements a client/server protocol for running single commands
on a remote host using Kerberos v5 authentication. If you want to use
remctl's PHP bindings, you need to install this package.

%package python
Summary: Python interface to remctl
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: python

%description python
remctl implements a client/server protocol for running single commands
on a remote host using Kerberos v5 authentication. If you want to use
remctl's Python bindings, you need to install this package.

%package ruby
Summary: Ruby interface to remctl
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
%if 0%{?rhel} && 0%{?rhel} <= 6
Requires: ruby(abi) = 1.8
%else
Requires: ruby(abi) = 1.9.1
%endif
Provides: ruby(remctl) = %{version}-%{release}

%description ruby
remctl implements a client/server protocol for running single commands
on a remote host using Kerberos v5 authentication. If you want to use
remctl's Ruby bindings, you need to install this package.

%prep
%setup -q

%build
export REMCTL_PERL_FLAGS="INSTALLDIRS=vendor"
%configure \
	--enable-perl \
	--enable-php \
	--enable-python \
	--enable-ruby \
	--disable-static
make
# Parallel builds are currently broken but hopefully fixed upstream.
# (Commit 5127bef5f3e771e3f142dc84ae88879eddc40a41)
# That should land in remctl > 3.2.
#make %%{?_smp_mflags}


%install
rm -rf %{buildroot}
make install \
	DESTDIR=%{buildroot} \
	INSTALL="install -p" \
	RUBYARCHDIR="%{buildroot}%{ruby_vendorarchdir}"

chmod 0755 %{buildroot}%{perl_vendorarch}/auto/Net/Remctl/Remctl.so
chmod 0644 %{buildroot}%{perl_vendorarch}/Net/Remctl.pm
chmod 0644 %{buildroot}%{_mandir}/man3/Net::Remctl.3pm*

# Tidy up the perl installation ...
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -type f -name perllocal.pod -exec rm -f {} ';'
find %{buildroot} -type f -name '*.bs' -a -size 0 -exec rm -f {} ';'
find %{buildroot} -depth -type d -exec rmdir {} 2>/dev/null ';'

# And the libraries
find %{buildroot} -type f -name '*.la' -exec rm -f {} ';'

# PHP configuration
mkdir -p %{buildroot}%{php_inidir}
install -p %{SOURCE1} %{buildroot}%{php_inidir}

%clean
rm -rf %{buildroot}

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files 
%defattr(-,root,root,-)
%doc README NEWS TODO
%{_libdir}/*.so.*
%{_bindir}/remctl
%{_sbindir}/remctld
%{_mandir}/man1/remctl*
%{_mandir}/man8/remctl*

%files devel
%defattr(-,root,root,-)
%{_includedir}/remctl.h
%{_mandir}/man3/remctl*
%{_libdir}/*.so
%{_libdir}/pkgconfig/libremctl.pc

%files perl
%defattr(-,root,root,-)
%{perl_vendorarch}/Net
%{perl_vendorarch}/auto/Net
%{_mandir}/man3/Net::Remctl*

%files php
%defattr(-,root,root,-)
%{php_extdir}/remctl.so
%config(noreplace) %{php_inidir}/remctl.ini

%files python
%defattr(-,root,root,-)
%{python_sitearch}/_remctl.so
%{python_sitearch}/remctl.py
%{python_sitearch}/remctl.pyc
%{python_sitearch}/remctl.pyo
%{!?el5: %{python_sitearch}/pyremctl-%{version}-*.egg-info}

%files ruby
%defattr(-,root,root,-)
%{ruby_vendorarchdir}/remctl.so


%changelog
* Wed Sep 26 2012 Ken Dreyer <ktdreyer@ktdreyer.com> - 3.3-1
- Upgrade to 3.3

* Mon Sep 03 2012 Ken Dreyer <ktdreyer@ktdreyer.com> - 3.2-5
- Fix PHP build for EL5
- Add remctl.ini PHP file

* Mon Sep 03 2012 Ken Dreyer <ktdreyer@ktdreyer.com> - 3.2-4
- Add PHP, Python, and Ruby bindings
- Drop separate Perl "vendor" patch in favor of using REMCTL_PERL_FLAGS

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu Jun 28 2012 Petr Pisar <ppisar@redhat.com> - 3.2-2
- Perl 5.16 rebuild

* Wed Jun 20 2012 Ken Dreyer <ktdreyer@ktdreyer.com> - 3.2-1
- Upgrade to 3.2

* Mon Jun 11 2012 Petr Pisar <ppisar@redhat.com> - 3.1-2
- Perl 5.16 rebuild

* Wed Feb 29 2012 Ken Dreyer <ktdreyer@ktdreyer.com> - 3.1-1
- Upgrade to 3.1

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Wed Nov 23 2011 Ken Dreyer <ktdreyer@ktdreyer.com> - 3.0-1
- Upgrade to 3.0

* Fri Jun 17 2011 Marcela Mašláňová <mmaslano@redhat.com> - 2.11-13
- Perl mass rebuild

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.11-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Jun 02 2010 Marcela Maslanova <mmaslano@redhat.com> - 2.11-11
- Mass rebuild with perl-5.12.0

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 2.11-10
- rebuild against perl 5.10.1

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.11-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.11-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Thu Jun 03 2008 Simon Wilkinson <simon@sxw.org.uk> 2.11-7
- Update to catch new perl version, and fix perl dependencies (#453579)

* Thu Feb 28 2008 Simon Wilkinson <simon@sxw.org.uk> 2.11-6
- The build process isn't -j safe, so remove smpflags until this can be fixed.

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 2.11-5
- Autorebuild for GCC 4.3

* Sat Jan 27 2008 Simon Wilkinson <simon@sxw.org.uk> 2.11-4
- More changes to address review comments

* Wed Jan 23 2008 Simon Wilkinson <simon@sxw.org.uk> 2.11-3
- Modifications for second round of review comments

* Tue Jan 22 2008 Simon Wilkinson <simon@sxw.org.uk> 2.11-2
- Modifications for first round of review comments
- Put perl modules in vendor_lib

* Mon Jan 14 2008 Simon Wilkinson <simon@sxw.org.uk> 2.11-1
- Upgrade to remctl 2.11

* Mon Oct  1 2007 Simon Wilkinson <simon@sxw.org.uk> 2.10-1
- Upgrade to remctl 2.10

* Sun Sep  2 2007 Simon Wilkinson <simon@sxw.org.uk> 2.9-1
- Initial specfile

